--- net/if_arp.c.orig	2005-01-22 06:02:02.000000000 +0900
+++ net/if_arp.c	2008-12-22 02:49:58.000000000 +0900
@@ -124,7 +124,11 @@
 	mib[2] = 0;
 	mib[3] = AF_INET;
 	mib[4] = NET_RT_FLAGS;
+#ifdef RTF_LLINFO
 	mib[5] = RTF_LLINFO;
+#else
+	mib[5] = 0;
+#endif
 	if (sysctl(mib, 6, NULL, &needed, NULL, 0) < 0)
 		return (-1);
 	needed += 128;
@@ -227,9 +231,14 @@
 	sdl = (struct sockaddr_dl *)(void *)
 	    (ROUNDUP(sin->sin_len) + (char *)sin);
 	if (sin->sin_addr.s_addr == sin_m.sin_addr.s_addr) {
+#ifdef RTF_LLINFO
 		if (sdl->sdl_family == AF_LINK
 		    && (rtm->rtm_flags & (RTF_LLINFO|RTF_GATEWAY))
 		      == RTF_LLINFO) {
+#else
+		if (sdl->sdl_family == AF_LINK &&
+		    !(rtm->rtm_flags & RTF_GATEWAY)) {
+#endif
 			switch (sdl->sdl_type) {
 			case IFT_ETHER:
 			case IFT_FDDI:

